{ EFLIB | Extended Function Library (C) Johan Larsson, 1992 - 1997
          All rights reserved. E-mail to jola@ts.umu.se.

          TEMPLATE UNITS                   [x] Real mode
        | Template/Filter.pas              [x] Protected mode

  This template shows how create your own filter, derived directly
  from the parent filter object in EFFILTER.

  This is a template unit, provided to make it easier for you to
  extend EFLIB for your own needs.

  EFLIB IS PROTECTED BY THE COPYRIGHT LAW AND MAY NOT BE MANIPULATED,
  DISTRIBUTED OR COPIED. THIS TEMPLATE UNIT MAY FREELY BE USED, MODIFIED
  AND DISTRIBUTED IN YOUR EFLIB DEVELOPED APPLICATION.                    }

unit Template;


INTERFACE

uses EFKERNEL, EFFILTER;

type pTemplateFilter = ^tTemplateFilter;
     tTemplateFilter = object (tFilter)

       { Template fitler object. }

       public

         constructor Initialize (Stream : pStream);

         procedure   Read (var Data; Count : word); virtual;
         procedure   Write (var Data; Count : word); virtual;

         { The parent filter object automatically passes stream
           operations (Reset, Truncate, etc) to the base stream. }

     end;


IMPLEMENTATION

constructor tTemplateFilter.Initialize (Stream : pStream);
begin
     { The inherited initialize constructor must be called to setup
       the base stream properly. }

     Inherited Initialize (Stream);

     { ... }
end;


procedure tTemplateFilter.Read (var Data; Count : word);
begin
     Inherited Read (Data, Count);

     { A filter should filter the data before returning it to
       the caller. For example, a filter could decompress, encrypt
       or validate the read data. }

     { ... }
end;


procedure tTemplateFilter.Write (var Data; Count : word);
begin
     { Filter the data before it is written to the base stream. }

     { ... }

     Inherited Write (Data, Count);
end;


end.